searchData={"items":[{"type":"task","title":"mix age.edit","doc":"","ref":"Mix.Tasks.Age.Edit.html"},{"type":"function","title":"Mix.Tasks.Age.Edit.run/1","doc":"","ref":"Mix.Tasks.Age.Edit.html#run/1"},{"type":"task","title":"mix age.encrypt","doc":"","ref":"Mix.Tasks.Age.Encrypt.html"},{"type":"function","title":"Mix.Tasks.Age.Encrypt.run/1","doc":"","ref":"Mix.Tasks.Age.Encrypt.html#run/1"},{"type":"task","title":"mix age.gen.key","doc":"","ref":"Mix.Tasks.Age.Gen.Key.html"},{"type":"function","title":"Mix.Tasks.Age.Gen.Key.run/1","doc":"","ref":"Mix.Tasks.Age.Gen.Key.html#run/1"},{"type":"task","title":"mix age.install","doc":"","ref":"Mix.Tasks.Age.Install.html"},{"type":"function","title":"Mix.Tasks.Age.Install.run/1","doc":"","ref":"Mix.Tasks.Age.Install.html#run/1"},{"type":"module","title":"SecretMana","doc":"SecretMana is a module for managing encrypted secrets using age (https://github.com/FiloSottile/age).\n\nThis module provides functionality to:\n- Read encrypted secrets\n- Edit secrets with your preferred editor\n- Encrypt/decrypt files\n- Generate age keys\n- Install the age binary\n\nSecretMana supports both JSON and YAML formats for secret files.","ref":"SecretMana.html"},{"type":"function","title":"SecretMana.edit/0","doc":"Opens the decrypted secrets in your editor for modification, then re-encrypts them when done.\n\nUses the EDITOR environment variable to determine which editor to use, falls back to vim if not set.","ref":"SecretMana.html#edit/0"},{"type":"function","title":"Examples - SecretMana.edit/0","doc":"SecretMana.edit()","ref":"SecretMana.html#edit/0-examples"},{"type":"function","title":"SecretMana.encrypt/2","doc":"Encrypts a file using the age public key.\n\nThe file must be in the format specified by the configuration (JSON or YAML).","ref":"SecretMana.html#encrypt/2"},{"type":"function","title":"Parameters - SecretMana.encrypt/2","doc":"* `file` - Path to the file to encrypt","ref":"SecretMana.html#encrypt/2-parameters"},{"type":"function","title":"Examples - SecretMana.encrypt/2","doc":"SecretMana.encrypt(\"secrets.json\")","ref":"SecretMana.html#encrypt/2-examples"},{"type":"function","title":"SecretMana.gen_key/0","doc":"Generates a new age key pair in the configured directory.\n\nCreates both a private key file and a public key file.","ref":"SecretMana.html#gen_key/0"},{"type":"function","title":"Examples - SecretMana.gen_key/0","doc":"SecretMana.gen_key()","ref":"SecretMana.html#gen_key/0-examples"},{"type":"function","title":"SecretMana.install/0","doc":"Downloads and installs the age binary for the current platform.\n\nAutomatically detects the correct version based on the current system architecture.","ref":"SecretMana.html#install/0"},{"type":"function","title":"Examples - SecretMana.install/0","doc":"SecretMana.install()","ref":"SecretMana.html#install/0-examples"},{"type":"function","title":"SecretMana.read/1","doc":"Reads and decrypts secrets from the configured secret file.","ref":"SecretMana.html#read/1"},{"type":"function","title":"Parameters - SecretMana.read/1","doc":"* `path` - Optional list of keys to traverse the secret structure, defaults to nil which returns the entire secret","ref":"SecretMana.html#read/1-parameters"},{"type":"function","title":"Examples - SecretMana.read/1","doc":"# Read all secrets\n    SecretMana.read()\n\n    # Read a specific nested key\n    SecretMana.read([\"database\", \"password\"])","ref":"SecretMana.html#read/1-examples"},{"type":"function","title":"SecretMana.start/2","doc":"","ref":"SecretMana.html#start/2"},{"type":"module","title":"SecretMana.Config","doc":"","ref":"SecretMana.Config.html"},{"type":"function","title":"SecretMana.Config.age_bin_path/0","doc":"","ref":"SecretMana.Config.html#age_bin_path/0"},{"type":"function","title":"SecretMana.Config.age_keygen_bin_path/0","doc":"","ref":"SecretMana.Config.html#age_keygen_bin_path/0"},{"type":"function","title":"SecretMana.Config.base_path/0","doc":"","ref":"SecretMana.Config.html#base_path/0"},{"type":"function","title":"SecretMana.Config.bin_dir/0","doc":"","ref":"SecretMana.Config.html#bin_dir/0"},{"type":"function","title":"SecretMana.Config.default_base_path/0","doc":"","ref":"SecretMana.Config.html#default_base_path/0"},{"type":"function","title":"SecretMana.Config.default_base_url/0","doc":"","ref":"SecretMana.Config.html#default_base_url/0"},{"type":"function","title":"SecretMana.Config.default_key_file/0","doc":"","ref":"SecretMana.Config.html#default_key_file/0"},{"type":"function","title":"SecretMana.Config.default_pub_key_file/0","doc":"","ref":"SecretMana.Config.html#default_pub_key_file/0"},{"type":"function","title":"SecretMana.Config.default_secret_file/0","doc":"","ref":"SecretMana.Config.html#default_secret_file/0"},{"type":"function","title":"SecretMana.Config.file_type/0","doc":"","ref":"SecretMana.Config.html#file_type/0"},{"type":"function","title":"SecretMana.Config.key_file/0","doc":"","ref":"SecretMana.Config.html#key_file/0"},{"type":"function","title":"SecretMana.Config.local_install/0","doc":"","ref":"SecretMana.Config.html#local_install/0"},{"type":"function","title":"SecretMana.Config.otp_app/0","doc":"","ref":"SecretMana.Config.html#otp_app/0"},{"type":"function","title":"SecretMana.Config.otp_version/0","doc":"","ref":"SecretMana.Config.html#otp_version/0"},{"type":"function","title":"SecretMana.Config.protocol_versions/0","doc":"","ref":"SecretMana.Config.html#protocol_versions/0"},{"type":"function","title":"SecretMana.Config.pub_key_file/0","doc":"","ref":"SecretMana.Config.html#pub_key_file/0"},{"type":"function","title":"SecretMana.Config.secret_file/0","doc":"","ref":"SecretMana.Config.html#secret_file/0"},{"type":"function","title":"SecretMana.Config.target/0","doc":"","ref":"SecretMana.Config.html#target/0"},{"type":"function","title":"SecretMana.Config.version/0","doc":"","ref":"SecretMana.Config.html#version/0"},{"type":"extras","title":"Changelog","doc":"<!-- @format -->\n\n# Changelog","ref":"changelog.html"},{"type":"extras","title":"v0.0.4 (2024-03-22) - Changelog","doc":"- Fix pathes by using otp app path.","ref":"changelog.html#v0-0-4-2024-03-22"},{"type":"extras","title":"v0.0.3 (2024-03-21) - Changelog","doc":"- Allow enabling/disabling local_install (helpful for deployments and CIs)","ref":"changelog.html#v0-0-3-2024-03-21"},{"type":"extras","title":"v0.0.2 (2024-03-21) - Changelog","doc":"","ref":"changelog.html#v0-0-2-2024-03-21"},{"type":"extras","title":"Fixes - Changelog","doc":"- Fix file type checking by skipping after editing.","ref":"changelog.html#fixes"},{"type":"extras","title":"v0.0.1 (2024-03-21) - Changelog","doc":"","ref":"changelog.html#v0-0-1-2024-03-21"},{"type":"extras","title":"Features - Changelog","doc":"- Initial release of SecretMana\n- Automatic installation of age binaries for different operating systems\n- Support for managing encrypted secrets in JSON and YAML formats\n- Read encrypted secrets with support for nested keys\n- Edit secrets with your preferred editor (uses $EDITOR or falls back to vim)\n- Encrypt files using age with public key encryption\n- Generate new age key pairs\n- Configuration system with sensible defaults and customization options","ref":"changelog.html#features"},{"type":"extras","title":"Implementation Details - Changelog","doc":"- Automatic detection of system architecture for binary downloads\n- Support for Darwin (macOS), Linux, and Windows platforms\n- Secure SSL connections for downloading binaries\n- Fallback mechanisms for different network configurations","ref":"changelog.html#implementation-details"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}